import { EntityRepository, Repository } from "typeorm";
import { UpdateAboutPageSectionTwoCmsDto } from "./dto/update-about-page-section-two-cms.dto";
import { AboutPageSectionTwoCmsEntity } from "./entities/about-page-section-two-cms.entity";

@EntityRepository(AboutPageSectionTwoCmsEntity)
export class AboutPageSectionTwoCmsRepository extends Repository<AboutPageSectionTwoCmsEntity> {

    async createEntity(dto: UpdateAboutPageSectionTwoCmsDto): Promise<AboutPageSectionTwoCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                imageOne: dto.imageOne,
                titleOne: dto.titleOne,
                descriptionOne: dto.descriptionOne,
                imageTwo: dto.imageTwo,
                titleTwo: dto.titleTwo,
                descriptionTwo: dto.descriptionTwo,
                imageThree: dto.imageThree,
                titleThree: dto.titleThree,
                descriptionThree: dto.descriptionThree
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateAboutPageSectionTwoCmsDto, id: string): Promise<AboutPageSectionTwoCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                imageOne: dto.imageOne,
                titleOne: dto.titleOne,
                descriptionOne: dto.descriptionOne,
                imageTwo: dto.imageTwo,
                titleTwo: dto.titleTwo,
                descriptionTwo: dto.descriptionTwo,
                imageThree: dto.imageThree,
                titleThree: dto.titleThree,
                descriptionThree: dto.descriptionThree
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<AboutPageSectionTwoCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}