import { EntityRepository, Repository } from "typeorm";
import { UpdateBenefitsSectionCmsDto } from "./dto/update-benefits-section-cms.dto";
import { BenefitsSectionCmsEntity } from "./entities/benefits-section-cms.entity";

@EntityRepository(BenefitsSectionCmsEntity)
export class BenefitsSectionCmsRepository extends Repository<BenefitsSectionCmsEntity> {

    async createEntity(dto: UpdateBenefitsSectionCmsDto): Promise<BenefitsSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                imageOne: dto.imageOne,
                titleOne: dto.titleOne,
                descriptionOne: dto.descriptionOne,
                buttonOneText: dto.buttonOneText,
                buttonOneLink: dto.buttonOneLink,
                imageTwo: dto.imageTwo,
                titleTwo: dto.titleTwo,
                descriptionTwo: dto.descriptionTwo,
                buttonTwoText: dto.buttonTwoText,
                buttonTwoLink: dto.buttonTwoLink,
                imageThree: dto.imageThree,
                titleThree: dto.titleThree,
                descriptionThree: dto.descriptionThree,
                buttonThreeText: dto.buttonThreeText,
                buttonThreeLink: dto.buttonThreeLink,
                sectionButtonText: dto.sectionButtonText
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateBenefitsSectionCmsDto, id: string): Promise<BenefitsSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                imageOne: dto.imageOne,
                titleOne: dto.titleOne,
                descriptionOne: dto.descriptionOne,
                buttonOneText: dto.buttonOneText,
                buttonOneLink: dto.buttonOneLink,
                imageTwo: dto.imageTwo,
                titleTwo: dto.titleTwo,
                descriptionTwo: dto.descriptionTwo,
                buttonTwoText: dto.buttonTwoText,
                buttonTwoLink: dto.buttonTwoLink,
                imageThree: dto.imageThree,
                titleThree: dto.titleThree,
                descriptionThree: dto.descriptionThree,
                buttonThreeText: dto.buttonThreeText,
                buttonThreeLink: dto.buttonThreeLink,
                sectionButtonText: dto.sectionButtonText
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<BenefitsSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}