import { Module } from "@nestjs/common";
import { TypeOrmModule } from "@nestjs/typeorm";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { FileUploadsService } from "src/modules/file-uploads/file-uploads.service";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";
import { HomePageCommonBannerCmsRepository } from "./home-page-common-banner-cms.repository";
import { HomePageCommonBannerCmsController } from "./home-page-common-banner-cms.controller";
import { HomePageCommonBannerCmsService } from "./home-page-common-banner-cms.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([HomePageCommonBannerCmsRepository])
    ],
    controllers: [HomePageCommonBannerCmsController],
    providers: [HomePageCommonBannerCmsService, JwtHelper, FileUploadsService, DoSpacesService, DoSpacesServicerovider]
})
export class HomePageCommonBannerCmsModule {
}