import {
    Body,
    Controller,
    Get,
    HttpCode,
    HttpStatus,
    Post,
    UploadedFiles,
    UseGuards,
    UseInterceptors
} from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { HomePageSectionSevenCmsService } from "./home-page-section-seven-cms.service";
import { UpdateHomePageSectionSevenCmsDto } from "./dto/update-home-page-section-seven-cms.dto";
import { FileFieldsInterceptor } from "@nestjs/platform-express";
import { UploadedMulterFileI } from "../../SpacesModule/SpacesService";

@Controller({ path: "home-page-section-seven-cms", version: Constants.API_VERSION_1 })

export class HomePageSectionSevenCmsController {
    constructor(private readonly service: HomePageSectionSevenCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    @UseInterceptors(FileFieldsInterceptor(
      [
          { name: "image", maxCount: 1 }
      ]
    ))
    updateOrCreateData(
      @Body() dto: UpdateHomePageSectionSevenCmsDto,
      @UploadedFiles() files: {
          image: UploadedMulterFileI,
      }
    ) {
        return this.service.updateOrCreateData(dto, files);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
