import { EntityRepository, Repository } from "typeorm";
import { UpdateHomePageSectionSevenCmsDto } from "./dto/update-home-page-section-seven-cms.dto";
import { HomePageSectionSevenCms } from "./entities/home-page-section-seven-cms.entity";

@EntityRepository(HomePageSectionSevenCms)
export class HomePageSectionSevenCmsRepository extends Repository<HomePageSectionSevenCms> {

    async createEntity(dto: UpdateHomePageSectionSevenCmsDto): Promise<HomePageSectionSevenCms | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                image: dto.image,
                bgColor: dto.bgColor,
                isImageOrColor: dto.isImageOrColor,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageSectionSevenCmsDto, id: string): Promise<HomePageSectionSevenCms | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                image: dto.image,
                bgColor: dto.bgColor,
                isImageOrColor: dto.isImageOrColor,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageSectionSevenCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}