import { EntityRepository, Repository } from "typeorm";
import { pageSchemaDto } from "./dto/page-schema.dto";
import { PageSchema } from "./entities/page-schema.entity";

@EntityRepository(PageSchema)
export class PageSchemaRepository extends Repository<PageSchema> {

    async createEntity(dto: pageSchemaDto): Promise<PageSchema | Error> {
        try {
            const entity = this.create({ ...dto });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: pageSchemaDto, id: string): Promise<PageSchema | Error> {
        try {
            await this.update(id, { ...dto });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PageSchema[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}