import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { DoSpacesServicerovider } from "../SpacesModule/SpacesService";
import { DoSpacesService } from "../SpacesModule/SpacesService/doSpacesService";
import { BenefitsContentController } from "./benefits-content.controller";
import { BenefitsContentRepository } from "./benefits-content.repository";
import { BenefitsContentService } from "./benefits-content.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([BenefitsContentRepository])
    ],
    controllers: [BenefitsContentController],
    providers: [BenefitsContentService, JwtHelper, DoSpacesService, DoSpacesServicerovider]
})
export class BenefitsContentModule {
}
