import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { DoSpacesServicerovider } from "../SpacesModule/SpacesService";
import { DoSpacesService } from "../SpacesModule/SpacesService/doSpacesService";
import { BenefitsModalController } from "./benefits-modal.controller";
import { BenefitsModalRepository } from "./benefits-modal.repository";
import { BenefitsModalService } from "./benefits-modal.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([BenefitsModalRepository])
    ],
    controllers: [BenefitsModalController],
    providers: [BenefitsModalService, JwtHelper, DoSpacesService, DoSpacesServicerovider]
})
export class BenefitsModalModule {
}
