import { Body, Controller, Delete, Get, Param, Post, UseGuards } from "@nestjs/common";
import { Constants } from "src/utils/constants";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { CareerApplicantService } from "./career-applicant.service";
import { CreateCareerApplicantDto } from "./dto/create-career-applicant.dto";
import { UploadedFiles, UseInterceptors } from "@nestjs/common/decorators";
import { FileFieldsInterceptor } from "@nestjs/platform-express";
import { UploadedMulterFileI } from "../SpacesModule/SpacesService";

@Controller({ path: "career-applicant", version: Constants.API_VERSION_1 })

export class CareerApplicantController {
    constructor(private readonly service: CareerApplicantService) {
    }

    @Post()
    // @UseGuards(AdminAuthGuard)
    // @UseInterceptors(FileFieldsInterceptor(
    //   [
    //       { name: "resume", maxCount: 1 }
    //   ]
    // ))
    create(
      @Body() dto: CreateCareerApplicantDto,
      // @UploadedFiles() files: {
      //     resume: UploadedMulterFileI
      // }
    ) {
        return this.service.create(dto);
    }

    @Get()
    @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }

    @Get(":id")
    @UseGuards(AdminAuthGuard)
    findOne(@Param("id") id: string) {
        return this.service.findOne(id);
    }

    @Delete(":id")
    @UseGuards(AdminAuthGuard)
    async remove(@Param("id") id: string) {
        return await this.service.remove(id);
    }
}
