import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { ContactPageUiService } from "./contact-page-ui.service";
import { UpdateContactPageUiDto } from "./dto/update-contact-page-ui.dto";

@Controller({ path: "contact-page-component-ui", version: Constants.API_VERSION_1 })

export class ContactPageUiController {
    constructor(private readonly service: ContactPageUiService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateContactPageUiDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
