import { Body, Controller, HttpStatus, Post } from "@nestjs/common";
import { DutchiePlusProductService } from "./dutchie-plus-product.service";
import { Constants } from "src/utils/constants";
import { Get, HttpCode } from "@nestjs/common/decorators";

@Controller({
    path: "product",
    version: Constants.API_VERSION_1
})
export class DutchiePlusProductController {
    constructor(private readonly dutchiePlusProductService: DutchiePlusProductService) {
    }

    @Get("/custom-filter-list")
    customFilterList() {
        return this.dutchiePlusProductService.customFilterList();
    }

    @Post("/all")
    @HttpCode(HttpStatus.OK)
    findAll(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.findAll(variables);
    }

    @Post("/details")
    @HttpCode(HttpStatus.OK)
    findOne(@Body() variables: any) {
        return this.dutchiePlusProductService.findOne(variables);
    }

    @Post("/filter")
    @HttpCode(HttpStatus.OK)
    filterProducts(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.filterProducts(variables);
    }

    @Post("/brands")
    @HttpCode(HttpStatus.OK)
    findAllBrands(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.findAllBrands(variables);
    }

    @Post("/category")
    @HttpCode(HttpStatus.OK)
    findAllCategory(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.findUniqueCategory(variables);
    }

    @Post("/effects")
    @HttpCode(HttpStatus.OK)
    findAllEffects(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.findAllEffects(variables);
    }

    @Post("/strain-type")
    @HttpCode(HttpStatus.OK)
    findAllStrainType(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.findAllStrainType(variables);
    }

    @Post("/filter-list")
    @HttpCode(HttpStatus.OK)
    filterList(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.filterList(variables);
    }

    @Post("/unique-effects")
    @HttpCode(HttpStatus.OK)
    findAllUniqueEffects(
      @Body() variables: any
    ) {
        return this.dutchiePlusProductService.findAllUniqueEffects(variables);
    }
}
